#include <algorithm>
#include <vector>
#include <iostream>
#include <cstdio>

int main() {

	typedef long long t_long;

	FILE *out = fopen("output.txt", "wb"), *inp = fopen("input.txt", "rb");

	std::vector<std::vector<t_long>> LEN;
	unsigned dim; fscanf(inp, "%u", &dim); LEN.resize(dim + 1);
	unsigned num;
	for (int i = 0; i < dim; ++ i) {
		fscanf(inp, "%u", &num);
		LEN[i].resize(num, 0);
	}
	LEN[dim].resize(
	LEN[dim - 1].size(), 0
	);

	//Заполняем вспомогательный массив, хранящий информацию о размерностях
	t_long sum = 0;
	for (int j = 0; j < LEN[dim - 1].size(); ++ j) {
		sum += (LEN[dim - 1][j] = 1);
	}
	for (int i = dim - 2; i >= 0; -- i) {
		t_long s1 = 0, s2 = 0;
		for (int j = 0; j < LEN[i].size(); ++ j) {
			LEN[i][j] = sum - s2;
			s2 += LEN[i + 1][j];
			s1 += LEN[i][j];
		}
		sum = s1;
	}
	for (int i = 0; i < dim; ++ i) {
		t_long s1 = 0, s2 = 0;
		for (int j = 0; j < LEN[i].size(); ++ j) {
			s1 = LEN[i][j] + s2;
			LEN[i][j] = s2;
			s2 = s1;
		}
	}

	//Считываем и выполняем запросы
	std::vector<int> IND(dim);
	fscanf(inp, "%u", &num);
	while (num --) {

		t_long pos; char key; fscanf(inp, " %c", &key);

		//'f':
		if (key == 'f') {

			for (int &n: IND) fscanf(inp, "%i", &n);

			std::sort(IND.begin(), IND.end());
			t_long pos = 0;
			for (int i = 0; i < dim; ++ i) {
				int k = IND[i];
				pos += LEN[i][k] - LEN[i + 1][k];
			}
			fprintf(out, "%lli\n", pos);
		}
		else
		//'b':
		if (key == 'b') {

			fscanf(inp, "%lli", &pos);

			for (int i = 0; i < dim; ++ i) {
				int j = std::upper_bound(
				    LEN[i].begin(), LEN[i].end(), pos
				) - LEN[i].begin() - 1;
				pos -= LEN[i][j] - LEN[i + 1][j];
				if (i) fprintf(out, " ");
				fprintf(out, "%i", j);
			}
			fprintf(out, "\n");
		}
		else {
			throw -1;
		}
	}

	fclose(out);
	fclose(inp);

	return 0;
}
